function f = like_simple_rho(b,nm,numind,t,M_sex,M_nosex,W_sex,W_nosex,LAG_S,type,grade,boy,sid,RS,SG,SR,PG,PB,PH,PO,G1,G3,R1,R2,YY,NY,SR_bl,pctbl,norm,c,Pmatch,G,cens_mat_g,cens_mat_r,cens_mat_none,race,frac_f,frac_m,Pmatchf,Pmatchm)
  
 
beta=b;
rho=-exp(beta(1));
A=exp(beta(2));
b=[beta(3:16)];

c= 1;%(exp(beta(16)))./(1+exp(beta(16))) ;
  Ns = max(sid);
%k=1;
Ptempf=zeros(nm,nm);
Ptempm=zeros(nm,nm);
 
 for k=1:Ns
%while k<Ns+1 %Ns is number of schools

	%STEP 1: Calculate baseline utlities for all own/partner characteristics
	%rows are own characteristics, columns are partner characteristics
	%Separate matrix for males and females and for different past sex
	u_norm_f(:,:,k) =  G3*b(2) + R1*b(5) + 3.*b(4) ; 
	u_norm_m(:,:,k) =  G3*b(2) + R1*b(5) + 3.*b(3) ; 
 
 
    Uf1(:,:,k)=b(12)*SR_bl+RS.*b(1)+SG*b(2)+SR*b(5)+PG.*b(4)+PB.*b(7)+PH.*b(9)+PO.*b(11)+RS.*b(13)    +(G).*b(14).*RS     -u_norm_f(:,:,k) ;
	Uf2(:,:,k)=b(12)*SR_bl+RS.*b(1)+SG*b(2)+SR*b(5)+PG.*b(4)+PB.*b(7)+PH.*b(9)+PO.*b(11) 		      +(G).*b(14).*RS     -u_norm_f(:,:,k) ;
	Um1(:,:,k)=b(12)*SR_bl+RS.*b(1)+SG*b(2)+SR*b(5)+PG.*b(3)+PB.*b(6)+PH.*b(8)+PO.*b(10)+RS.*b(13)    +(G).*b(14).*RS    -u_norm_m(:,:,k) ;
	Um2(:,:,k)=b(12)*SR_bl+RS.*b(1)+SG*b(2)+SR*b(5)+PG.*b(3)+PB.*b(6)+PH.*b(8)+PO.*b(10)		      +(G).*b(14).*RS   -u_norm_m(:,:,k) ;
 
    
   
    Ptempf=Pmatchf(:,:,k) ;
	 
    Ptempm=Pmatchm(:,:,k) ;
	
    Nf1t=[  W_sex(:,k)*ones(1,t)    W_sex(:,k)*ones(1,t) ]  ;
    Nf2t=[  W_nosex(:,k)*ones(1,t)  W_nosex(:,k)*ones(1,t) ]  ;

	Nm1t=[  M_sex(:,k)*ones(1,t)   M_sex(:,k)*ones(1,t) ]  ; 
	Nm2t=[  M_nosex(:,k)*ones(1,t)    M_nosex(:,k)*ones(1,t)]  ;
 
 
	Ptempfo=zeros(t,nm);%nm is number of characteristics
    Ptempmo=zeros(t,nm);
	
    uf1temp=Uf1(:,:,k);
	uf2temp=Uf2(:,:,k);
	um1temp=Um1(:,:,k);
	um2temp=Um2(:,:,k);
	count=0;
	tmp= max(max(max([abs(Ptempfo-Ptempf) abs(Ptempmo-Ptempm)]))) ;%max(max(abs(Ptempfo-Ptempf)))+max(max(abs(Ptempmo-Ptempm))) ;
    while count==0%tmp>.0001
    
        Ptempfo=Ptempf;
        Ptempmo=Ptempm;
		
        Uf1t=c*uf1temp;%+c*log(Ptempf./(Ptempf(:,norm)*ones(1,nm)));
		Uf2t=c*uf2temp;%+c*log(Ptempf./(Ptempf(:,norm)*ones(1,nm)));       
	    Um1t=c*um1temp;%+c*log(Ptempm./(Ptempm(:,norm)*ones(1,nm)));
        Um2t=c*um2temp;%+c*log(Ptempm./(Ptempm(:,norm)*ones(1,nm)))	;

        Pf1t=exp(Uf1t)./(sum(exp(Uf1t),2)*ones(1,nm));%adj is a 1 x number of partner characteristics
        Pm1t=exp(Um1t)./(sum(exp(Um1t),2)*ones(1,nm));
        Pf2t=exp(Uf2t)./(sum(exp(Uf2t),2)*ones(1,nm));
		Pm2t=exp(Um2t)./(sum(exp(Um2t),2)*ones(1,nm));
		Sft=Nf1t.*Pf1t+Nf2t.*Pf2t;
        Smt=Nm1t.*Pm1t+Nm2t.*Pm2t;
 
		zero_m = (Smt==0);
		%old type in zero
		%zero_f = (Smt==0);
		zero_f = (Sft==0);

		%1 size zero
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_m==0);  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_f==0);  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_m==0) ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_f==0) ;
		%new zero
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_m==0).*(zero_f==0);  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_f==0).*(zero_m==0);  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_m==0).*(zero_f==0) ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_f==0).*(zero_m==0) ;
		%baseline zero
		Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_f==0);  
		Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_m==0);  
        Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_f==0) ;
        Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_m==0) ;
		%no zeroing
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))) ;  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))) ;  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho))  ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho))  ;
		
		
		%[sum(sum(Ptempf>=1)) sum(sum(Ptempm>=1))] 
		
		one_mat_f = (Ptempf>=1);
		one_mat_m = (Ptempm>=1);
		
		%Ptempf_leon(:,1:t).*(one_mat_m(:,1:t)'==1)
		
		Ptempf(:,1:t) = Ptempf(:,1:t).*(one_mat_m(:,1:t)'==0) + Ptempf_leon(:,1:t).*(one_mat_m(:,1:t)'==1);
		Ptempm(:,1:t) = Ptempm(:,1:t).*(one_mat_f(:,1:t)'==0) + Ptempm_leon(:,1:t).*(one_mat_f(:,1:t)'==1);
		Ptempf(:,t+1:2*t) = Ptempf(:,t+1:2*t).*(one_mat_m(:,t+1:2*t)'==0) + Ptempf_leon(:,t+1:2*t).*(one_mat_m(:,t+1:2*t)'==1);
		Ptempm(:,t+1:2*t) = Ptempm(:,t+1:2*t).*(one_mat_f(:,t+1:2*t)'==0) + Ptempm_leon(:,t+1:2*t).*(one_mat_f(:,t+1:2*t)'==1);
		
		%[sum(sum(Ptempf>=1)) sum(sum(Ptempm>=1))] 
		
		Ptempf=max(min(.99999,Ptempf),.00001);
        Ptempm=max(min(.99999,Ptempm),.00001);
        
		%Ptempf=.75*Ptempf + .25*Ptempfo;
		%Ptempm=.75*Ptempm + .25*Ptempmo;
		
		tmp= max(max(max([abs(Ptempfo-Ptempf) abs(Ptempmo-Ptempm)])))   ;  
		count=count+1;
	 	if count>600
	 		Pmatchf_new = .5*ones(t,nm,Ns); 
	 		Pmatchm_new = .5*ones(t,nm,Ns); 
			Uf1 = .5*ones(t,nm,Ns);
			Uf2 = .5*ones(t,nm,Ns);
			Um1 = .5*ones(t,nm,Ns);
			Um2 = .5*ones(t,nm,Ns);
	 		tmp =0;
			k=Ns+1;
	 	end
	end

    Pmatchf_new(:,:,k)=Ptempf;
    Pmatchm_new(:,:,k)=Ptempm;
 
    Psearchf1_new(:,:,k)=Pf1t;% Sft./(Nf1t+Nf2t + (Nf1t+Nf2t==0)).*(Nf1t+Nf2t>0);
    Psearchm1_new(:,:,k)=Pm1t;% Smt./(Nm1t+Nm2t + (Nm1t+Nm2t==0)).*(Nm1t+Nm2t>0);
    Psearchf2_new(:,:,k)=Pf2t;%Sft./(Nf1t+Nf2t);
    Psearchm2_new(:,:,k)=Pm2t;%Smt./(Nm1t+Nm2t);
	
	Psearch_male(:,:,k)  = (Nm1t+Nm2t>0).*(Pm1t.*Nm1t+Pm2t.*Nm2t)./(Nm1t+Nm2t + (Nm1t+Nm2t==0));

    %k=k+1;
end 


%[temp1; temp2; temp3]
Pmatchf = Pmatchf_new;
Pmatchm = Pmatchm_new;
 
for i=1:numind
	U_ts(i,:) = Uf1(type(i),:,sid(i)).*(boy(i)==0)+Um1(type(i),:,sid(i)).*(boy(i)==1);
	U_tns(i,:) = Uf2(type(i),:,sid(i)).*(boy(i)==0)+Um2(type(i),:,sid(i)).*(boy(i)==1);
	Pmatch(i,:) = Pmatchf(type(i),:,sid(i)).*(boy(i)==0)+Pmatchm(type(i),:,sid(i)).*(boy(i)==1);
end
 	
fi_s_ne=exp(c*U_ts)./(sum(exp(c*U_ts),2)*ones(1,nm));
fi_ns_ne=exp(c*U_tns)./(sum(exp(c*U_tns),2)*ones(1,nm));
fi_ne=LAG_S.*fi_s_ne + (1-LAG_S).*fi_ns_ne;
  
MU=log(Pmatch./(Pmatch(:,norm)*ones(1,nm))); %note: A will always cancel out in the  utility function
U_s=c*(U_ts+MU);
fi_s=exp(U_s)./(sum(exp(U_s),2)*ones(1,nm));
U_ns=c*(U_tns+MU);
fi_ns=exp(U_ns)./(sum(exp(U_ns),2)*ones(1,nm));

Psearch=LAG_S.*fi_s + (1-LAG_S).*fi_ns;
 
fi_ts=exp(c*U_ts)./(sum(exp(c*U_ts),2)*ones(1,nm));
fi_tns=exp(c*U_tns)./(sum(exp(c*U_tns),2)*ones(1,nm));
Psearch_t=LAG_S.*fi_ts + (1-LAG_S).*fi_tns;


cens_like = sum( cens_mat_g.*Psearch.*Pmatch + cens_mat_r.*Psearch.*Pmatch + cens_mat_none.*Psearch.*Pmatch,2)   ;
  
f=-sum(sum(YY.*(log(Psearch)+log(Pmatch)),2)+NY.*log(sum(Psearch.*(1-Pmatch),2))) - sum(log(cens_like +  (cens_like==0) ))  ;

 
info = [b; c; f/100; mean(mean(sum(Psearch_male(:,1:t,:)))); mean(mean(sum(Psearchm1_new(:,1:t,:)))); mean(mean(sum(Psearchf1_new(:,1:t,:))));   mean(mean(sum(Psearchm2_new(:,1:t,:)))); mean(mean(sum(Psearchf2_new(:,1:t,:))));    mean(sum(Psearch_t(boy==1,1:16),2)); mean(sum(Psearch_t(boy==0,1:16),2)) ]  ;
 
 
save est_noeq	 info 
 