clear all
 
 cd /home/beauchaa/AddHealth/PMP_Paper
 
set mem 1g
set maxvar 10000
*use "datasetlessinfo.dta"
 run datasetlessinfodo_71112_nolove_samecens3.do

*run datasetlessinfodo_71112_nolove_newcens2.do
*run datasetlessinfodo_71112.do
*run datasetlessinfodo_52113_nolove.do
*run datasetlessinfodo_52113_nolove_nopagefill.do
*run datasetlessinfodo_52113_nolove_nopagefill_dos.do
*run datasetlessinfodo_52113_nolove_dos.do
 
*goes back to weighted sample
drop if gswgt1==.

*P out
gen sf =1
*gen sf = .66

gen sm = 0
*gen sm = .25
*gen sm = .50

tab boys
 
gen matchout  = ((sexcurall==1&sexcurallss==0)|(relcurall==1&relcurallss==0))
gen matchever = (rel1+rel2+rel3+rel1nx+rel2nx+rel3nx+rel1nr+rel2nr+rel3nr+sexin1+sexin2+sexin3+sexin1nx+sexin2nx+sexin3nx+sexin1nr+sexin2nr+sexin3nr+sexprior+hadsex+matchout>0)


******************************************************************************************************
*No grade filling, with all grade and race information across all relationship reports
*_ngfill_wallrginfo
******************************************************************************************************
gen curpartrace = 0
replace curpartrace = partrace3nr if current3nr == 1&sameschool3nr==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace2nr if current2nr == 1&sameschool2nr==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace1nr if current1nr == 1&sameschool1nr==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace3nx if current3nx == 1&sameschool3nx==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace2nx if current2nx == 1&sameschool2nx==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace1nx if current1nx == 1&sameschool1nx==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace3 if current3 == 1 &sameschool3==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace2 if current2 == 1 &sameschool2==1&(sexcurallss==1|relcurallss==1)
replace curpartrace = partrace1 if current1 == 1 &sameschool1==1&(sexcurallss==1|relcurallss==1)
 
gen curpartgrade = 0
replace curpartgrade = partgrade3nr if current3nx == 1&sameschool3nx==1&(sexcurallss==1|relcurallss==1)
replace curpartgrade = partgrade2nr if current2nx == 1&sameschool2nx==1&(sexcurallss==1|relcurallss==1)
replace curpartgrade = partgrade1nr if current1nx == 1&sameschool1nx==1&(sexcurallss==1|relcurallss==1)
replace curpartgrade = partgrade3 if current3 == 1 &sameschool3==1&(sexcurallss==1|relcurallss==1)
replace curpartgrade = partgrade2 if current2 == 1 &sameschool2==1&(sexcurallss==1|relcurallss==1)
replace curpartgrade = partgrade1 if current1 == 1 &sameschool1==1&(sexcurallss==1|relcurallss==1)

 
  /*

  ******************************************************************************************************
*with grade filling, with all grade and race information from only relationship-relationship reports
*_wgfill_nallrginfo
******************************************************************************************************
*using only reports from the relationship relationships
gen curpartrace = 0
replace curpartrace = partrace1 if current1 == 1
replace curpartrace = partrace2 if current2 == 1
replace curpartrace = partrace3 if current3 == 1
gen curpartracenr=0
*these are un used information in this run of the data
replace curpartracenr = partrace1nr if current1nr == 1
replace curpartracenr = partrace2nr if current2nr == 1
replace curpartracenr = partrace3nr if current3nr == 1
gen curpartracenx=0
replace curpartracenx = partrace1nx if current1nx == 1
replace curpartracenx = partrace2nx if current2nx == 1
replace curpartracenx = partrace3nx if current3nx == 1 
replace curpartrace = 0 if curpartrace == 5
replace curpartracenr = 0 if curpartracenr == 5
replace curpartracenx = 0 if curpartracenx == 5

gen curpartgrade = 0
replace curpartgrade = partgrade1 if current1 == 1
replace curpartgrade = partgrade2 if current2 == 1
replace curpartgrade = partgrade3 if current3 == 1

gen curpartage=0
replace curpartage= partage1 if current1 == 1
replace curpartage = partage2 if current2 == 1
replace curpartage = partage3 if current3 == 1
replace curpartage = partage1nr if current1nr == 1
replace curpartage = partage2nr if current2nr == 1
replace  curpartage = partage3nr if current3nr == 1
replace curpartgrade = 1 if (sexcurallss==1|relcurallss==1)&curpartgrade==0&curpartage==1
replace curpartgrade = 2 if (sexcurallss==1|relcurallss==1)&curpartgrade==0&curpartage==2
replace curpartgrade = 3 if (sexcurallss==1|relcurallss==1)&curpartgrade==0&curpartage==4
replace curpartgrade = 4 if (sexcurallss==1|relcurallss==1)&curpartgrade==0&curpartage==5
drop if curpartrace  == 0&(sexcurallss==1|relcurallss==1)
drop if curpartgrade == 0&(sexcurallss==1|relcurallss==1)
 */
*********************************************************
*Correcting NSW,NSM for those who search outside the school
********************************************************* 

egen scid_pred1 = group(scid)
gen sp_pred = sexprior
egen scid_pred = group(scid_pred1)
gen outmatch = ((sexcurall==1&sexcurallss==0)|(relcurall==1&relcurallss==0))
gen grade_pred = grade
gen race_pred = race
qui xi: logit outmatch i.race_pred i.grade_pred i.scid_pred if boys==1
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
gen temp = 0

forvalues i = 1(1)4{
forvalues j = 9(1)12{
qui gen g`j'r`i'sm_out  = 0
qui gen g`j'r`i'sf_out  = 0
}
}
 
replace sp_pred = .3923
forvalues i = 1(1)4{
forvalues j = 9(1)12{
forvalues s = 1(1)74 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
 qui replace _Igrade_pre_10=0
 qui replace _Igrade_pre_11=0
 qui replace _Igrade_pre_12=0
 qui replace _Igrade_pre_`j'=1
*qui replace grade_pred = `j'
drop temp
qui predict temp
qui replace g`j'r`i'sm_out  = temp if scid_pred == `s'
}
}
}

drop scid_pred* _I* temp
gen scid_pred1 = scid
replace sp_pred = sexprior
replace scid_pred1 = 2 if scid_pred1 ==1
egen scid_pred = group(scid_pred1)
replace grade_pred = grade
qui xi: logit outmatch i.race_pred i.grade_pred i.scid_pred if boys==0
gen _Irace_pred_1 = 0
 gen _Igrade_pre_9 = 0
gen temp = 0
  
replace sp_pred = .32014

forvalues i = 1(1)4{
forvalues j = 9(1)12{
forvalues s = 1(1)73 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
 qui replace _Igrade_pre_10=0
 qui replace _Igrade_pre_11=0
 qui replace _Igrade_pre_12=0
 qui replace _Igrade_pre_`j'=1
*qui replace grade_pred = `j'
drop temp
qui predict temp
qui replace g`j'r`i'sf_out  = temp if scid_pred == `s' 
}
}
}

drop scid_pred* _I* temp
gen scid_pred1 = scid
replace sp_pred = sexprior
replace grade_pred= grade
replace scid_pred1 = 1 if scid_pred1 == 80
egen scid_pred = group(scid_pred1)
gen inmatch = ((sexcurallss==1)|(relcurallss==1))
qui xi: logit inmatch i.race_pred i.grade_pred i.scid_pred  if boys==1 
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
gen temp = 0
forvalues i = 1(1)4{
forvalues j = 9(1)12{
gen g`j'r`i'sm_in = 0
}
}
replace sp_pred = .3923

forvalues i = 1(1)4{
forvalues j = 9(1)12{
forvalues s = 1(1)74 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
 qui replace _Igrade_pre_10=0
 qui replace _Igrade_pre_11=0
 qui replace _Igrade_pre_12=0
 qui replace _Igrade_pre_`j'=1
*qui replace grade_pred = `j'
drop temp
qui predict temp
qui replace g`j'r`i'sm_in  = temp  if scid_pred == `s'
 }
}
}

drop scid_pred* _I* temp
gen scid_pred1 = scid
replace sp_pred = sexprior
replace scid_pred1 = 1 if scid_pred1 ==80
egen scid_pred = group(scid_pred1)
replace grade_pred = grade
qui xi: logit inmatch i.race_pred i.grade_pred i.scid_pred if boys==0
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
gen temp = 0
 
forvalues i = 1(1)4{
forvalues j = 9(1)12{
gen g`j'r`i'sf_in = 0
}
} 
 
replace sp_pred = .32014 

forvalues i = 1(1)4{
forvalues j = 9(1)12{
 forvalues s = 1(1)74{
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
 qui replace _Igrade_pre_10=0
 qui replace _Igrade_pre_11=0
 qui replace _Igrade_pre_12=0
 qui replace _Igrade_pre_`j'=1
*qui replace grade_pred = `j'
drop temp
qui predict temp
qui replace g`j'r`i'sf_in  = temp if scid_pred == `s' 
}
}
}

drop scid_pred* _I* temp
gen scid_pred1 = scid



replace grade_pred = grade

egen scid_pred = group(scid_pred1)

qui xi: logit matchever i.race_pred i.grade_pred i.scid_pred if boys==1
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
gen temp = 0
 
forvalues i = 1(1)4{
forvalues j = 9(1)12{
gen g`j'r`i'sm_ever = .
forvalues s = 1(1)75 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
qui replace _Igrade_pre_10=0
qui replace _Igrade_pre_11=0
qui replace _Igrade_pre_12=0
qui replace _Igrade_pre_`j'=1
drop temp
qui predict temp
qui replace g`j'r`i'sm_ever  = temp if scid_pred == `s' 
}
}
}
 
drop scid_pred* _I* temp
gen scid_pred1 = scid

*replace scid_pred1 = 2 if scid_pred1 ==1
egen scid_pred = group(scid_pred1)

qui xi: logit matchever i.race_pred i.grade_pred i.scid_pred if boys==0 
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
gen temp = 0
 
forvalues i = 1(1)4{
forvalues j = 9(1)12{
gen g`j'r`i'sf_ever = .
forvalues s = 1(1)75 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
qui replace _Igrade_pre_10=0
qui replace _Igrade_pre_11=0
qui replace _Igrade_pre_12=0
qui replace _Igrade_pre_`j'=1
drop temp
qui predict temp
qui replace g`j'r`i'sf_ever  = temp if scid_pred == `s' 
}
}
} 

*CREATING SCALE FACTORS (SF) BASED ON BOUNDING OF P_MATCH OUT
gen g9r1sm_sf  = g9r1sm_out/g9r1sm_in
replace g9r1sm_sf = .10 if g9r1sm_sf == .
gen g10r1sm_sf = g10r1sm_out/g10r1sm_in
replace g10r1sm_sf = .10 if g10r1sm_sf == .
gen g11r1sm_sf = g11r1sm_out/g11r1sm_in
replace g11r1sm_sf = .10 if g11r1sm_sf == .
gen g12r1sm_sf = g12r1sm_out/g12r1sm_in
replace g12r1sm_sf = .10 if g12r1sm_sf == .

gen g9r1sf_sf  = g9r1sf_out/g9r1sf_in
replace g9r1sf_sf = .10 if g9r1sf_sf == .
gen g10r1sf_sf = g10r1sf_out/g10r1sf_in
replace g10r1sf_sf = .10 if g10r1sf_sf == .
gen g11r1sf_sf = g11r1sf_out/g11r1sf_in
replace g11r1sf_sf = .10 if g11r1sf_sf == .
gen g12r1sf_sf = g12r1sf_out/g12r1sf_in
replace g12r1sf_sf = .10 if g12r1sf_sf == .

gen g9r2sm_sf  = g9r2sm_out/g9r2sm_in
replace g9r2sm_sf = .10 if g9r2sm_sf == .
gen g10r2sm_sf = g10r2sm_out/g10r2sm_in
replace g10r2sm_sf = .10 if g10r2sm_sf == .
gen g11r2sm_sf = g11r2sm_out/g11r2sm_in
replace g11r2sm_sf = .10 if g11r2sm_sf == .
gen g12r2sm_sf = g12r2sm_out/g12r2sm_in
replace g12r2sm_sf = .10 if g12r2sm_sf == .

gen g9r2sf_sf  = g9r2sf_out/g9r2sf_in
replace g9r2sf_sf = .10 if g9r2sf_sf == .
gen g10r2sf_sf = g10r2sf_out/g10r2sf_in
replace g10r2sf_sf = .10 if g10r2sf_sf == .
gen g11r2sf_sf = g11r2sf_out/g11r2sf_in
replace g11r2sf_sf = .10 if g11r2sf_sf == .
gen g12r2sf_sf = g12r2sf_out/g12r2sf_in
replace g12r2sf_sf = .10 if g12r2sf_sf == .

gen g9r3sm_sf  = g9r3sm_out/g9r3sm_in
replace g9r3sm_sf = .10 if g9r3sm_sf == .
gen g10r3sm_sf = g10r3sm_out/g10r3sm_in
replace g10r3sm_sf = .10 if g10r3sm_sf == .
gen g11r3sm_sf = g11r3sm_out/g11r3sm_in
replace g11r3sm_sf = .10 if g11r3sm_sf == .
gen g12r3sm_sf = g12r3sm_out/g12r3sm_in
replace g12r3sm_sf = .10 if g12r3sm_sf == .

gen g9r3sf_sf  = g9r3sf_out/g9r3sf_in
replace g9r3sf_sf = .10 if g9r3sf_sf == .
gen g10r3sf_sf = g10r3sf_out/g10r3sf_in
replace g10r3sf_sf = .10 if g10r3sf_sf == .
gen g11r3sf_sf = g11r3sf_out/g11r3sf_in
replace g11r3sf_sf = .10 if g11r3sf_sf == .
gen g12r3sf_sf = g12r3sf_out/g12r3sf_in
replace g12r3sf_sf = .10 if g12r3sf_sf == .
 
gen g9r4sm_sf  = g9r4sm_out/g9r4sm_in
replace g9r4sm_sf = .10 if g9r4sm_sf == .
gen g10r4sm_sf = g10r4sm_out/g10r4sm_in
replace g10r4sm_sf = .10 if g10r4sm_sf == .
gen g11r4sm_sf = g11r4sm_out/g11r4sm_in
replace g11r4sm_sf = .10 if g11r4sm_sf == .
gen g12r4sm_sf = g12r4sm_out/g12r4sm_in
replace g12r4sm_sf = .10 if g12r4sm_sf == .

gen g9r4sf_sf  = g9r4sf_out/g9r4sf_in
replace g9r4sf_sf = .10 if g9r4sf_sf == .
gen g10r4sf_sf = g10r4sf_out/g10r4sf_in
replace g10r4sf_sf = .10 if g10r4sf_sf == .
gen g11r4sf_sf = g11r4sf_out/g11r4sf_in
replace g11r4sf_sf = .10 if g11r4sf_sf == .
gen g12r4sf_sf = g12r4sf_out/g12r4sf_in
replace g12r4sf_sf = .10 if g12r4sf_sf == .
 
replace hsg9r1sm = hsg9r1sm*(1 -  g9r1sm_out*g9r1sm_sf -  (1-g9r1sm_ever)*sm )
replace hsg10r1sm = hsg10r1sm*(1 -  g10r1sm_out*g10r1sm_sf-  (1-g10r1sm_ever)*sm)
replace hsg11r1sm = hsg11r1sm*(1 -  g11r1sm_out*g11r1sm_sf-  (1-g11r1sm_ever)*sm)
replace hsg12r1sm = hsg12r1sm*(1 -  g12r1sm_out*g12r1sm_sf-  (1-g12r1sm_ever)*sm)

replace hsg9r2sm = hsg9r2sm*(1 -  g9r2sm_out*g9r2sm_sf-  (1-g9r2sm_ever)*sm  )
replace hsg10r2sm = hsg10r2sm*(1 -  g10r2sm_out*g10r2sm_sf-  (1-g10r2sm_ever)*sm  )
replace hsg11r2sm = hsg11r2sm*(1 -  g11r2sm_out*g11r2sm_sf-  (1-g11r2sm_ever)*sm  )
replace hsg12r2sm = hsg12r2sm*(1 -  g12r2sm_out*g12r2sm_sf-  (1-g12r2sm_ever)*sm  )

replace hsg9r3sm = hsg9r3sm*(1 -  g9r3sm_out*g9r3sm_sf-  (1-g9r3sm_ever)*sm   )
replace hsg10r3sm = hsg10r3sm*(1 -  g10r3sm_out*g10r3sm_sf-  (1-g10r3sm_ever)*sm  )
replace hsg11r3sm = hsg11r3sm*(1 -  g11r3sm_out*g11r3sm_sf-  (1-g11r3sm_ever)*sm  )
replace hsg12r3sm = hsg12r3sm*(1 -  g12r3sm_out*g12r3sm_sf-  (1-g12r3sm_ever)*sm  )
 
replace hsg9r4sm = hsg9r4sm*(1 -  g9r4sm_out*g9r4sm_sf-  (1-g9r4sm_ever)*sm )
replace hsg10r4sm = hsg10r4sm*(1 -  g10r4sm_out*g10r4sm_sf- (1-g10r4sm_ever)*sm )
replace hsg11r4sm = hsg11r4sm*(1 - g11r4sm_out*g11r4sm_sf-  (1-g11r4sm_ever)*sm )
replace hsg12r4sm = hsg12r4sm*(1 -  g12r4sm_out*g12r4sm_sf- (1-g12r4sm_ever)*sm )

replace hsg9r5sm = hsg9r5sm*(1 -  g9r4sm_out*g9r4sm_sf-   (1-g9r4sm_ever)*sm )
replace hsg10r5sm = hsg10r5sm*(1 - g10r4sm_out*g10r4sm_sf- (1-g10r4sm_ever)*sm )
replace hsg11r5sm = hsg11r5sm*(1 - g11r4sm_out*g11r4sm_sf- (1-g11r4sm_ever)*sm )
replace hsg12r5sm = hsg12r5sm*(1 - g12r4sm_out*g12r4sm_sf- (1-g12r4sm_ever)*sm )
   
replace hsg9r1sf = hsg9r1sf*(1 -  g9r1sf_out*g9r1sf_sf -  (1-g9r1sf_ever)*sm )
replace hsg10r1sf = hsg10r1sf*(1 -  g10r1sf_out*g10r1sf_sf-  (1-g10r1sf_ever)*sm)
replace hsg11r1sf = hsg11r1sf*(1 -  g11r1sf_out*g11r1sf_sf-  (1-g11r1sf_ever)*sm)
replace hsg12r1sf = hsg12r1sf*(1 -  g12r1sf_out*g12r1sf_sf-  (1-g12r1sf_ever)*sm)

replace hsg9r2sf = hsg9r2sf*(1 -  g9r2sf_out*g9r2sf_sf-  (1-g9r2sf_ever)*sm  )
replace hsg10r2sf = hsg10r2sf*(1 -  g10r2sf_out*g10r2sf_sf-  (1-g10r2sf_ever)*sm  )
replace hsg11r2sf = hsg11r2sf*(1 -  g11r2sf_out*g11r2sf_sf-  (1-g11r2sf_ever)*sm  )
replace hsg12r2sf = hsg12r2sf*(1 -  g12r2sf_out*g12r2sf_sf-  (1-g12r2sf_ever)*sm  )

replace hsg9r3sf = hsg9r3sf*(1 -  g9r3sf_out*g9r3sf_sf-  (1-g9r3sf_ever)*sm   )
replace hsg10r3sf = hsg10r3sf*(1 -  g10r3sf_out*g10r3sf_sf-  (1-g10r3sf_ever)*sm  )
replace hsg11r3sf = hsg11r3sf*(1 -  g11r3sf_out*g11r3sf_sf-  (1-g11r3sf_ever)*sm  )
replace hsg12r3sf = hsg12r3sf*(1 -  g12r3sf_out*g12r3sf_sf-  (1-g12r3sf_ever)*sm  )
 
replace hsg9r4sf = hsg9r4sf*(1 -  g9r4sf_out*g9r4sf_sf-  (1-g9r4sf_ever)*sm )
replace hsg10r4sf = hsg10r4sf*(1 -  g10r4sf_out*g10r4sf_sf- (1-g10r4sf_ever)*sm )
replace hsg11r4sf = hsg11r4sf*(1 - g11r4sf_out*g11r4sf_sf-  (1-g11r4sf_ever)*sm )
replace hsg12r4sf = hsg12r4sf*(1 -  g12r4sf_out*g12r4sf_sf- (1-g12r4sf_ever)*sm )

replace hsg9r5sf = hsg9r5sf*(1 -  g9r4sf_out*g9r4sf_sf-   (1-g9r4sf_ever)*sm )
replace hsg10r5sf = hsg10r5sf*(1 - g10r4sf_out*g10r4sf_sf- (1-g10r4sf_ever)*sm )
replace hsg11r5sf = hsg11r5sf*(1 - g11r4sf_out*g11r4sf_sf- (1-g11r4sf_ever)*sm )
replace hsg12r5sf = hsg12r5sf*(1 - g12r4sf_out*g12r4sf_sf- (1-g12r4sf_ever)*sm )


gen matchall = (match==1|matchout==1|inmatch==1)

*run searchout_correction_bound.do


gen randy = runiform()
sort randy 
drop if matchever==0&(randy<sm)


*drop if searchout==1 

*drop if ((sexcur==1&sexcurss==0)|(relcur==1&relcurss==0))
*droppping those matching outsdie schools

 
drop if ((sexcurall==1&sexcurallss==0)|(relcurall==1&relcurallss==0))


*dropping those with partner grades outside the current school
drop if curpartgrade==-1|curpartgrade==5 
 
*generates the no-cens sample
*drop if curpartrace  == 0&(sexcurallss==1|relcurallss==1)
*drop if curpartgrade == 0&(sexcurallss==1|relcurallss==1)

gen censsample =  (curpartrace  == 0|curpartgrade == 0)&(sexcurallss==1|relcurallss==1)
mean sexprior if (sexcurallss==1|relcurallss==1)  , over(censsample)
 

 
 
tab boys
 
 drop scid_pred* _I*  

egen scid_pred1 = group(scid)
replace scid_pred1 = 1 if scid_pred1 == 2|scid_pred1==60
egen scid_pred = group(scid_pred1)
 
qui xi: logit sexprior i.race_pred i.grade_pred i.scid_pred if boys==1
gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
 
forvalues i = 1(1)4{
forvalues j = 9(1)12{
forvalues s = 1(1)72 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
qui replace _Igrade_pre_10=0
qui replace _Igrade_pre_11=0
qui replace _Igrade_pre_12=0
qui replace _Igrade_pre_`j'=1
drop temp
qui predict temp
qui replace ssexm`j'r`i' = temp if scid_pred == `s' 
}
}
}


drop scid_pred* _I*
gen scid_pred1 = scid
replace scid_pred1 = 1 if scid_pred1 ==28
egen scid_pred = group(scid_pred1)

qui xi: logit sexprior i.race_pred i.grade_pred i.scid_pred if boys==0 

gen _Irace_pred_1 = 0
gen _Igrade_pre_9 = 0
replace temp = 0


forvalues i = 1(1)4{
forvalues j = 9(1)12{
forvalues s = 1(1)73 {
qui replace _Irace_pred_2=0
qui replace _Irace_pred_3=0
qui replace _Irace_pred_4=0
qui replace _Irace_pred_`i'=1
qui replace _Igrade_pre_10=0
qui replace _Igrade_pre_11=0
qui replace _Igrade_pre_12=0
qui replace _Igrade_pre_`j'=1
drop temp
qui predict temp
qui replace ssexf`j'r`i' = temp if scid_pred == `s' 
}
}
}

drop m12r* m11r* m10r* m9r* 
 
sum ssexf* ssexm* 
 
replace curpartrace = 4 if curpartrace ==5

gen Yli = 1*(sexcurallss==1) + 2*(sexcurallss==0&relcurallss==1)
gen Yliss = 0
replace Yliss = curpartgrade if Yli==1&curpartgrade>0
replace Yliss = 4 + curpartgrade if Yli == 2&curpartgrade>0 
gen Yliss_r=0
replace Yliss_r = curpartrace if Yli==1&curpartrace>0
replace Yliss_r = 4 + curpartrace if Yli == 2&curpartrace>0

egen sid1 = group(sid)
replace sid = sid1
*drop if sid==72|sid==75
drop if hsg9r1sm==.
drop if ssexm9r1 ==.
drop if sexprior ==.
drop if hsg11r1sm==0&hsg11r2sm==0

tab boys

replace grade = grade-8

egen sid3 = group(sid) if boys==0
replace sid = sid3


mean wantsex, over(boys)

*mean wantsex, over(boys grade)
*mean wantsex, over(boys race)

drop if boys==1

 
*Dropping Data we don't need
drop *_new hsr* *_me *low *hi *med
keep sid SSsample SchType boys grade Yliss* Yli sexcurallss relcurallss hsg* hs* nhs* race ssex* upsexcurallss  sexprior
*sum 
* tab Yliss Yliss_r if Yli>0
 
 outsheet using "baseline_ngfill_wallrginfo_pout1_drop0.csv", nol noq replace
 /*outsheet using "baseline_ngfill_wallrginfo_pout1_drop25.csv", nol noq replace
 outsheet using "baseline_ngfill_wallrginfo_pout1_drop50.csv", nol noq replace
 outsheet using "baseline_ngfill_wallrginfo_pout66_drop0.csv", nol noq replace
 outsheet using "baseline_ngfill_wallrginfo_pout66_drop25.csv", nol noq replace
 outsheet using "baseline_ngfill_wallrginfo_pout66_drop50.csv", nol noq replace

