function f = like_simple_rho(b,nm,numind,t,M_sex,M_nosex,W_sex,W_nosex,LAG_S,type,grade,boy,sid,RS,SG,SR,PG,PB,PH,PO,G1,G3,R1,R2,YY,NY,SR_bl,pctbl,norm,c,Pmatch,G,cens_mat_g,cens_mat_r,cens_mat_none,race,frac_f,frac_m,Pmatchf,Pmatchm)
 
 %global Pmatchf Pmatchm
 
beta=b;
rho=-exp(beta(1));
A=exp(beta(2));
b=[beta(1:5); 0; 0; beta(6:12) ; 0;  beta(13:15);  0];
b(20) =  0;%beta(16);
%beta(16)
 c= (exp(beta(16)))./(1+exp(beta(16))) ;
b(21:22 ) =  beta(17:18);
 c2= (exp(beta(19)))./(1+exp(beta(19))) ;

%#8
% b(23:40 ) = beta(19:36);
%#9
% b(23:36) = beta(19:32);
%#9
%b(23:37 ) = beta(19:33);


%b(23:24) = beta(18:19);
Ns = max(sid);
%k=1;
Ptempf=zeros(nm,nm);
Ptempm=zeros(nm,nm);
 
 for k=1:Ns
%while k<Ns+1 %Ns is number of schools

	%STEP 1: Calculate baseline utlities for all own/partner characteristics
	%rows are own characteristics, columns are partner characteristics
	%Separate matrix for males and females and for different past sex
	u_norm_f(:,:,k) =  G3*b(5) + R1*b(8) + 3.*b(18) + b(20).*frac_m(norm,k)*ones(t,nm) ; 
	u_norm_m(:,:,k) =  G3*b(5) + R1*b(8) + 3.*b(17) + b(20).*frac_f(norm,k)*ones(t,nm)   ; 
 
    
     %Adding Race interactions by RS  (#4)
     %RS.*(SR*b(23)+PB.*b(25)+PH.*b(27)+PO.*b(29)+b(31)*SR_bl)
     %RS.*(SR*b(24)+PB.*b(26)+PH.*b(28)+PO.*b(30)+b(32)*SR_bl)
     %Adding PG profiles by RS (#3)
     %(PG).*RS.*b(24)
     %adding grade x race (R1 claims grade won't measure age, especially
     %across races. suggests (although we can't use age because of data
     %restrictions) that grade effects should be different across ages. (#5) 
     %#5
     %G.*(SR*b(23)+PB.*b(25)+PH.*b(27)+PO.*b(29)+b(31)*SR_bl)
     %G.*(SR*b(24)+PB.*b(26)+PH.*b(28)+PO.*b(30)+b(32)*SR_bl)
     %#6
     %PG.*(SR*b(23)+PB.*b(25)+PH.*b(27)+PO.*b(29)+b(31)*SR_bl)
     %PG.*(SR*b(24)+PB.*b(26)+PH.*b(28)+PO.*b(30)+b(32)*SR_bl)
     %#7
     %G.*(PB.*b(23)+PH.*b(25)+PO.*b(27))
     %G.*(PB.*b(24)+PH.*b(26)+PO.*b(28))
     %#11
    
      %MT_f = G.*(PB.*b(23)+PH.*b(24)+PO.*b(25));
      %MT_m = G.*(PB.*b(23)+PH.*b(24)+PO.*b(25));
     %#8
     % MT_f = G.*(PB.*b(23)+PH.*b(25)+PO.*b(27)) + RS.*(PB.*b(29)+PH.*b(31)+PO.*b(33)) + PG.*(PB.*b(35)+PH.*b(37)+PO.*b(39));
     % MT_m = G.*(PB.*b(24)+PH.*b(26)+PO.*b(28)) + RS.*(PB.*b(30)+PH.*b(32)+PO.*b(34)) + PG.*(PB.*b(36)+PH.*b(38)+PO.*b(40)) ;
     %#9
     %MT_f = G.*(PB.*b(23)+PH.*b(24)+PO.*b(25)) + RS.*(PB.*b(26)+PH.*b(27)+PO.*b(28)) + PG.*(PB.*b(30)+PH.*b(31)+PO.*b(32));
     %MT_m = G.*(PB.*b(23)+PH.*b(24)+PO.*b(25)) + RS.*(PB.*b(26)+PH.*b(27)+PO.*b(29)) + PG.*(PB.*b(30)+PH.*b(31)+PO.*b(32)) ;
     %#10
     %MT_f = G.*(SR*b(23)+PB.*b(25)+PH.*b(27)+PO.*b(29)+b(31)*SR_bl) + RS.*(SR*b(33)+PB.*b(35)+PH.*b(37)+PO.*b(39)+b(41)*SR_bl) + PG.*(SR*b(43)+PB.*b(45)+PH.*b(47)+PO.*b(49)+b(51)*SR_bl);
     %MT_m = G.*(SR*b(24)+PB.*b(26)+PH.*b(28)+PO.*b(30)+b(32)*SR_bl) + RS.*(SR*b(34)+PB.*b(36)+PH.*b(38)+PO.*b(40)+b(42)*SR_bl) + PG.*(SR*b(44)+PB.*b(46)+PH.*b(48)+PO.*b(50)+b(52)*SR_bl) ;
     %#12
     %   MT_f = G.*(SR*b(23)+PB.*b(24)+PH.*b(25)+PO.*b(26)+b(27)*SR_bl) + RS.*(SR*b(28)+PB.*b(29)+PH.*b(30)+PO.*b(31)+b(32)*SR_bl) + PG.*(SR*b(33)+PB.*b(34)+PH.*b(35)+PO.*b(36)+b(37)*SR_bl);
     %   MT_m = G.*(SR*b(23)+PB.*b(24)+PH.*b(25)+PO.*b(26)+b(27)*SR_bl) + RS.*(SR*b(28)+PB.*b(29)+PH.*b(30)+PO.*b(31)+b(32)*SR_bl) + PG.*(SR*b(33)+PB.*b(34)+PH.*b(35)+PO.*b(36)+b(37)*SR_bl) ;
     
    MT_f = zeros(16,32);
    MT_m = zeros(16,32);
    
     
     Uf1(:,:,k)=b(15)*SR_bl+RS.*b(4)+SG*b(5)+SR*b(8)+PG.*b(7)+PB.*b(10)+PH.*b(12)+PO.*b(14)+RS.*b(16)  +(PG).*b(18)+(G).*b(22).*RS +  MT_f  + b(20).*(ones(t,1)*frac_m(:,k)')  -u_norm_f(:,:,k) ;
	Uf2(:,:,k)=b(15)*SR_bl+RS.*b(4)+SG*b(5)+SR*b(8)+PG.*b(7)+PB.*b(10)+PH.*b(12)+PO.*b(14) 		      +(PG).*b(18)+(G).*b(22).*RS +  MT_f  + b(20).*(ones(t,1)*frac_m(:,k)')  -u_norm_f(:,:,k) ;
	Um1(:,:,k)=b(15)*SR_bl+RS.*b(3)+SG*b(5)+SR*b(8)+PG.*b(6)+PB.*b(9)+PH.*b(11)+PO.*b(13)+RS.*b(16)   +(PG).*b(17)+(G).*b(21).*RS +  MT_m  + b(20).*(ones(t,1)*frac_f(:,k)')  -u_norm_m(:,:,k) ;
	Um2(:,:,k)=b(15)*SR_bl+RS.*b(3)+SG*b(5)+SR*b(8)+PG.*b(6)+PB.*b(9)+PH.*b(11)+PO.*b(13)		      +(PG).*b(17)+(G).*b(21).*RS +  MT_m  + b(20).*(ones(t,1)*frac_f(:,k)')  -u_norm_m(:,:,k) ;

	%STEP 2: Loop over schools to get match probabilities for each combination
	%Pmatch matrix is 3-D, with schools in the 3rd dimension
	%Again, separate matrix for men and women
	 
    Ptempf=Pmatchf(:,:,k) ;
	 
    Ptempm=Pmatchm(:,:,k) ;
	
    Nf1t=[  W_sex(:,k)*ones(1,t)    W_sex(:,k)*ones(1,t) ]  ;
    Nf2t=[  W_nosex(:,k)*ones(1,t)  W_nosex(:,k)*ones(1,t) ]  ;

	Nm1t=[  M_sex(:,k)*ones(1,t)   M_sex(:,k)*ones(1,t) ]  ; 
	Nm2t=[  M_nosex(:,k)*ones(1,t)    M_nosex(:,k)*ones(1,t)]  ;
 
 
	Ptempfo=zeros(t,nm);%nm is number of characteristics
    Ptempmo=zeros(t,nm);
	
    uf1temp=Uf1(:,:,k);
	uf2temp=Uf2(:,:,k);
	um1temp=Um1(:,:,k);
	um2temp=Um2(:,:,k);
	count=0;
	tmp= max(max(max([abs(Ptempfo-Ptempf) abs(Ptempmo-Ptempm)]))) ;%max(max(abs(Ptempfo-Ptempf)))+max(max(abs(Ptempmo-Ptempm))) ;
    while tmp>.0001
    
        Ptempfo=Ptempf;
        Ptempmo=Ptempm;
		
        Uf1t=c2.*uf1temp+c2.*log(Ptempf./(Ptempf(:,norm)*ones(1,nm)));
		Uf2t=c.*uf2temp+c.*log(Ptempf./(Ptempf(:,norm)*ones(1,nm)));       
	    Um1t=c2.*um1temp+c2.*log(Ptempm./(Ptempm(:,norm)*ones(1,nm)));
        Um2t=c.*um2temp+c.*log(Ptempm./(Ptempm(:,norm)*ones(1,nm)))	;

        Pf1t=exp(Uf1t)./(sum(exp(Uf1t),2)*ones(1,nm));%adj is a 1 x number of partner characteristics
        Pm1t=exp(Um1t)./(sum(exp(Um1t),2)*ones(1,nm));
        Pf2t=exp(Uf2t)./(sum(exp(Uf2t),2)*ones(1,nm));
		Pm2t=exp(Um2t)./(sum(exp(Um2t),2)*ones(1,nm));
		Sft=Nf1t.*Pf1t+Nf2t.*Pf2t;
        Smt=Nm1t.*Pm1t+Nm2t.*Pm2t;
 
		zero_m = (Smt==0);
		%old type in zero
		%zero_f = (Smt==0);
		zero_f = (Sft==0);

		%1 size zero
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_m==0);  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_f==0);  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_m==0) ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_f==0) ;
		%new zero
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_m==0).*(zero_f==0);  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_f==0).*(zero_m==0);  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_m==0).*(zero_f==0) ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_f==0).*(zero_m==0) ;
		%baseline zero
		Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))).*(zero_f==0);  
		Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))).*(zero_m==0);  
        Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_f==0) ;
        Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_m==0) ;
		%no zeroing
		% Ptempf_leon = (min([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)'],(Sft))./(Sft+(Sft==0))) ;  
		% Ptempm_leon = (min([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)'],(Smt))./(Smt+(Smt==0))) ;  
        % Ptempf= (A.*(.5+.5*([Smt(1:t,1:t)' Smt(1:t,t+1:2*t)']./(Sft+(Sft==0))).^rho).^(1/rho))  ;
        % Ptempm= (A.*(.5+.5*([Sft(1:t,1:t)' Sft(1:t,t+1:2*t)']./(Smt+(Smt==0))).^rho).^(1/rho))  ;
		
		
		%[sum(sum(Ptempf>=1)) sum(sum(Ptempm>=1))] 
		
		one_mat_f = (Ptempf>=1);
		one_mat_m = (Ptempm>=1);
		
		%Ptempf_leon(:,1:t).*(one_mat_m(:,1:t)'==1)
		
		Ptempf(:,1:t) = Ptempf(:,1:t).*(one_mat_m(:,1:t)'==0) + Ptempf_leon(:,1:t).*(one_mat_m(:,1:t)'==1);
		Ptempm(:,1:t) = Ptempm(:,1:t).*(one_mat_f(:,1:t)'==0) + Ptempm_leon(:,1:t).*(one_mat_f(:,1:t)'==1);
		Ptempf(:,t+1:2*t) = Ptempf(:,t+1:2*t).*(one_mat_m(:,t+1:2*t)'==0) + Ptempf_leon(:,t+1:2*t).*(one_mat_m(:,t+1:2*t)'==1);
		Ptempm(:,t+1:2*t) = Ptempm(:,t+1:2*t).*(one_mat_f(:,t+1:2*t)'==0) + Ptempm_leon(:,t+1:2*t).*(one_mat_f(:,t+1:2*t)'==1);
		
		%[sum(sum(Ptempf>=1)) sum(sum(Ptempm>=1))] 
		
		Ptempf=max(min(.99999,Ptempf),.00001);
        Ptempm=max(min(.99999,Ptempm),.00001);
        
		%Ptempf=.75*Ptempf + .25*Ptempfo;
		%Ptempm=.75*Ptempm + .25*Ptempmo;
		
		tmp= max(max(max([abs(Ptempfo-Ptempf) abs(Ptempmo-Ptempm)])))   ;  
		count=count+1;
	 	if count>600
	 		Pmatchf_new = .5*ones(t,nm,Ns); 
	 		Pmatchm_new = .5*ones(t,nm,Ns); 
			Uf1 = .5*ones(t,nm,Ns);
			Uf2 = .5*ones(t,nm,Ns);
			Um1 = .5*ones(t,nm,Ns);
			Um2 = .5*ones(t,nm,Ns);
	 		tmp =0;
			k=Ns+1;
	 	end
	end

    Pmatchf_new(:,:,k)=Ptempf;
    Pmatchm_new(:,:,k)=Ptempm;
 
    Psearchf1_new(:,:,k)=Pf1t;% Sft./(Nf1t+Nf2t + (Nf1t+Nf2t==0)).*(Nf1t+Nf2t>0);
    Psearchm1_new(:,:,k)=Pm1t;% Smt./(Nm1t+Nm2t + (Nm1t+Nm2t==0)).*(Nm1t+Nm2t>0);
    Psearchf2_new(:,:,k)=Pf2t;%Sft./(Nf1t+Nf2t);
    Psearchm2_new(:,:,k)=Pm2t;%Smt./(Nm1t+Nm2t);
	
	Psearch_male(:,:,k)  = (Nm1t+Nm2t>0).*(Pm1t.*Nm1t+Pm2t.*Nm2t)./(Nm1t+Nm2t + (Nm1t+Nm2t==0));

    %k=k+1;
end 


%[temp1; temp2; temp3]
Pmatchf = Pmatchf_new;
Pmatchm = Pmatchm_new;
 
for i=1:numind
	U_ts(i,:) = Uf1(type(i),:,sid(i)).*(boy(i)==0)+Um1(type(i),:,sid(i)).*(boy(i)==1);
	U_tns(i,:) = Uf2(type(i),:,sid(i)).*(boy(i)==0)+Um2(type(i),:,sid(i)).*(boy(i)==1);
	Pmatch(i,:) = Pmatchf(type(i),:,sid(i)).*(boy(i)==0)+Pmatchm(type(i),:,sid(i)).*(boy(i)==1);
 end
 	
fi_s_ne=exp(c2*U_ts)./(sum(exp(c2*U_ts),2)*ones(1,nm));
fi_ns_ne=exp(c*U_tns)./(sum(exp(c*U_tns),2)*ones(1,nm));
fi_ne=LAG_S.*fi_s_ne + (1-LAG_S).*fi_ns_ne;
  
MU=log(Pmatch./(Pmatch(:,norm)*ones(1,nm))); %note: A will always cancel out in the  utility function
U_s=c2*(U_ts+MU);
fi_s=exp(U_s)./(sum(exp(U_s),2)*ones(1,nm));
U_ns=c*(U_tns+MU);
fi_ns=exp(U_ns)./(sum(exp(U_ns),2)*ones(1,nm));

Psearch=LAG_S.*fi_s + (1-LAG_S).*fi_ns;
 
fi_ts=exp(c2*U_ts)./(sum(exp(c2*U_ts),2)*ones(1,nm));
fi_tns=exp(c*U_tns)./(sum(exp(c*U_tns),2)*ones(1,nm));
Psearch_t=LAG_S.*fi_ts + (1-LAG_S).*fi_tns;


cens_like = sum( cens_mat_g.*Psearch.*Pmatch + cens_mat_r.*Psearch.*Pmatch + cens_mat_none.*Psearch.*Pmatch,2)   ;
  
f=-sum(sum(YY.*(log(Psearch)+log(Pmatch)),2)+NY.*log(sum(Psearch.*(1-Pmatch),2))) - sum(log(cens_like +  (cens_like==0) ))  ;

 
info = [b; c; c2; f/100; mean(mean(sum(Psearch_male(:,1:t,:)))); mean(mean(sum(Psearchm1_new(:,1:t,:)))); mean(mean(sum(Psearchf1_new(:,1:t,:))));   mean(mean(sum(Psearchm2_new(:,1:t,:)))); mean(mean(sum(Psearchf2_new(:,1:t,:))));    mean(sum(Psearch_t(boy==1,1:16),2)); mean(sum(Psearch_t(boy==0,1:16),2)) ]  ;
 
save est_wcens_gs_wleon_modeltest_2scale	 info 
 