clear all
use /home/beauchaa/AddHealth/OriginalData/Core/ICPSR_27021/DS0022/27021-0022-Data-REST.dta
outsheet using schinfo.csv, nolabel
clear
insheet using schinfo.csv 

save schinfo.dta,replace
erase schinfo.csv 
 

clear all
set mem 1g
use "/home/beauchaa/AddHealth/UsableData/w1.dta"
joinby aid using 2nd.dta, unm(m) _merge(m2)
joinby scid using schinfo.dta, unm(m) _merge(m2a)

egen numhw1 = count(scid), by(scid)
drop if imonth == .
drop m2
save 3rd.dta, replace

sort scid
 
destring aschlcde, replace
sort aschlcde
by aschlcde: gen iSchType = 5
by aschlcde: replace iSchType = 1 if a1n == 1 & a1m == 1 & a1l == 1 & a1k == 1 & a1j == 0 & a1i == 0 & a1h == 0 & a1g == 0 & a1f == 0 & a1e == 0 
by aschlcde: replace iSchType = 2 if a1n == 1 & a1m == 1 & a1l == 1 & a1k == 0 & a1j == 0 & a1i == 0 & a1h == 0 & a1g == 0 & a1f == 0 & a1e == 0 
by aschlcde: replace iSchType = 3 if a1n == 1 & a1m == 1 & a1l == 1 & a1k == 1 & a1j == 1 & a1i == 1 & a1h == 0 & a1g == 0 & a1f == 0 & a1e == 0 
by aschlcde: replace iSchType = 4 if a1n == 0 & a1m == 0 & a1l == 0 & a1k == 1 & a1j == 1 & a1i == 1 & a1h == 0 & a1g == 0 & a1f == 0 & a1e == 0 

sort scid
by scid: egen SchType = min(iSchType)
by scid: egen urban = mode(aurban), min 	

la var SchType "1=High School 9-12, 2=Sr High 10-12, 3=Combined 7-12, 4=Jr High 7-9 5=Other Combined"

gen catholic = 0 
replace catholic = 1 if a2g == 1 | a2h == 1 | a2i == 1 
gen otherrel = 0 
replace otherrel = 1 if a2j == 1
gen otherpriv = 0
replace otherpriv = 1 if a2k == 1

gen public = 0
replace public = 1 if a2a == 1 | a2b == 1 | a2c == 1 
gen private = 0
replace private = 1 if a2g == 1 | a2h == 1 | a2i == 1 | a2j == 1 | a2k== 1 




save 3rd , replace
