
/*
***************************************
*DESCRIPTIVE STATS FOR PAPER**
***************************************
*TABLE 1
gen either =(sexcurallss==1|relcurallss==1)
mean sexcurallss relcurallss either, over(boys)
mean sexcurallss , over(boys race)
mean sexprior , over(boys race)


*TABLE 2
mean wantsex wantrel, over(boys)
mean wantsex, over(boys race)
mean wantsex, over(boys grade)
*alternative, conditional on wanting a relationship or sex
mean  wantsex wantrel if (wantsex==1|wantrel==1), over(boys)
mean  wantsex  if  (wantsex==1|wantrel==1), over(boys grade)
mean wantsex  if  (wantsex==1|wantrel==1), over(boys race)

*TABLE 3
gen pgrade = 0 if sexcurallss==1|relcurallss==1
replace pgrade = curpartgrade if sexcurallss==1
replace pgrade = curpartgrade if relcurallss==1
tab grade pgrade if (sexcurallss==1|relcurallss==1)&boys==0

*TABLE 4
gen prace = 0 if sexcurallss==1|relcurallss==1
replace prace = curpartrace if sexcurallss==1
replace prace = curpartrace if relcurallss==1
tab race prace if (sexcurallss==1|relcurallss==1)&boys==0

*Table 5
mean sexcurallss if wantsex==1, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==1 , s(N) by(boys) 

mean sexcurallss if wantsex==1&either==1, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==1&either==1 , s(N) by(boys) 
mean sexcurallss if wantsex==0&either==1, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==0&either==1 , s(N) by(boys) 

mean sexcurallss if wantsex==1&either==1&sexprior==0, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==1&either==1&sexprior==0 , s(N) by(boys) 
mean sexcurallss if wantsex==0&either==1&sexprior==0, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==0&either==1&sexprior==0 , s(N) by(boys) 

mean sexcurallss if wantsex==1&either==1&sexprior==1, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==1&either==1&sexprior==1 , s(N) by(boys) 
mean sexcurallss if wantsex==0&either==1&sexprior==1, over(boys)
lincom [sexcurallss]1 - [sexcurallss]0
tabstat sexcurallss if wantsex==0&either==1&sexprior==1 , s(N) by(boys) 

*/

