clear
 cd /home/beauchaa/AddHealth/PMP_Paper
*insheet using baseline_switchmatch_nolove_nocens_predps_fixouttypo.csv, case
insheet using baseline_ngfill_wallrginfo.csv

*insheet using baseline_ngfill_wallrginfo_unw.csv


*gen yliss= Yliss
*gen yli = Yli
*gen yliss_r = Yliss_r

gen girl = 1-boys 
gen match = (sexcurallss==1|relcurallss==1)
gen sex=(sexcurallss==1)
gen pgrade = 0 if sexcurallss==1|relcurallss==1
replace pgrade = yliss if sexcurallss==1&yliss>0
replace pgrade = yliss-4 if relcurallss==1&yliss>4

gen prace = 0 if sexcurallss==1|relcurallss==1
replace prace = yliss_r if sexcurallss==1&yliss_r>0
replace prace = yliss_r-4 if relcurallss==1&yliss_r>4


gen totstud = hsg9r1sm +  hsg10r1sm+ hsg11r1sm+ hsg12r1sm+ hsg9r1sf+ hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r2sm+ hsg10r2sm+ hsg11r2sm +hsg12r2sm +hsg9r2sf +hsg10r2sf+ hsg11r2sf+ hsg12r2sf +hsg9r3sm + hsg10r3sm+ hsg11r3sm+ hsg12r3sm+ hsg9r3sf +hsg10r3sf+ hsg11r3sf +hsg12r3sf +hsg9r4sm +hsg10r4sm+ hsg11r4sm+ hsg12r4sm+ hsg9r4sf+ hsg10r4sf+ hsg11r4sf +hsg12r4sf+ hsg9r5sm+ hsg10r5sm+ hsg11r5sm+ hsg12r5sm+ hsg9r5sf+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf

gen nr2 = hsg9r2sm +hsg10r2sm+ hsg11r2sm+ hsg12r2sm+ hsg10r2sf+ hsg11r2sf+ hsg12r2sf+ hsg9r2sf
gen nr1 = hsg9r1sm +hsg10r1sm+ hsg11r1sm+ hsg12r1sm+ hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r1sf
gen nr3 = hsg9r3sm +hsg10r3sm+ hsg11r3sm+ hsg12r3sm+ hsg10r3sf+ hsg11r3sf+ hsg12r3sf+ hsg9r3sf
gen nr4 = hsg9r4sm +hsg10r4sm+ hsg11r4sm+ hsg12r4sm+ hsg10r4sf+ hsg11r4sf+ hsg12r4sf+ hsg9r4sf+hsg9r5sm +hsg10r5sm+ hsg11r5sm+ hsg12r5sm+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf+ hsg9r5sf
 
 gen pctr1g9 = hsg9r1sf/(hsg9r2sm+hsg9r1sf)
 gen pctr1g10 = hsg10r1sf/(hsg10r2sm+hsg10r1sf)
 gen pctr1g11 = hsg11r1sf/(hsg11r2sm+hsg11r1sf)
 gen pctr1g12 = hsg12r1sf/(hsg12r2sm+hsg12r1sf)
 
 gen pctr2g9 = hsg9r2sf/(hsg9r2sm+hsg9r2sf)
 gen pctr2g10 = hsg10r2sf/(hsg10r2sm+hsg10r2sf)
 gen pctr2g11 = hsg11r2sf/(hsg11r2sm+hsg11r2sf)
 gen pctr2g12 = hsg12r2sf/(hsg12r2sm+hsg12r2sf)
 
gen pctr1 = (hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r1sf) / ( hsg9r1sm +hsg10r1sm+ hsg11r1sm+ hsg12r1sm ) 
gen pctr2 =  (hsg10r2sf+ hsg11r2sf+ hsg12r2sf+ hsg9r2sf) / (hsg9r2sm +hsg10r2sm+ hsg11r2sm+ hsg12r2sm )
gen pctr3=(hsg10r3sf+ hsg11r3sf+ hsg12r3sf+ hsg9r3sf)/(hsg9r3sm +hsg10r3sm+ hsg11r3sm+ hsg12r3sm)
gen pctr4=(hsg10r4sf+ hsg11r4sf+ hsg12r4sf+ hsg9r4sf+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf+ hsg9r5sf)/(hsg9r4sm +hsg10r4sm+ hsg11r4sm+ hsg12r4sm+hsg9r5sm +hsg10r5sm+ hsg11r5sm+ hsg12r5sm)
 
gen sexratio_ownrace = pctr1 if (race==1) 
replace sexratio_ownrace =  pctr2 if (race==2) 
replace sexratio_ownrace =  pctr3 if (race==3) 
replace sexratio_ownrace =  pctr4 if (race==4) 


gen sexratio_partrace = pctr1 if (prace==1) 
replace sexratio_partrace =  pctr2 if (prace==2) 
replace sexratio_partrace =  pctr3 if (prace==3) 
replace sexratio_partrace =  pctr4 if (prace==4) 

gen n9 = hsg9r1sm +hsg9r2sm+ hsg9r3sm+ hsg9r4sm+hsg9r5sm+ hsg9r2sf+ hsg9r3sf+ hsg9r4sf+ hsg9r1sf+hsg9r5sf
gen n10 = hsg10r1sm +hsg10r2sm+ hsg10r3sm+ hsg10r4sm+hsg10r5sm+ hsg10r2sf+ hsg10r3sf+ hsg10r4sf+ hsg10r1sf+hsg10r5sf
gen n11 = hsg11r1sm +hsg11r2sm+ hsg11r3sm+ hsg11r4sm+hsg11r5sm+ hsg11r2sf+ hsg11r3sf+ hsg11r4sf+ hsg11r1sf+hsg11r5sf
gen n12 = hsg12r1sm +hsg12r2sm+ hsg12r3sm+ hsg12r4sm+hsg12r5sm+ hsg12r2sf+ hsg12r3sf+ hsg12r4sf+ hsg12r1sf+hsg12r5sf


gen n9_sm = hsg9r1sm +hsg9r2sm+ hsg9r3sm+ hsg9r4sm+hsg9r5sm
gen n9_sf = hsg9r2sf+ hsg9r3sf+ hsg9r4sf+ hsg9r1sf+hsg9r5sf

gen n10_sm = hsg10r1sm +hsg10r2sm+ hsg10r3sm+ hsg10r4sm+hsg10r5sm
gen n10_sf = hsg10r2sf+ hsg10r3sf+ hsg10r4sf+ hsg10r1sf+hsg10r5sf
gen n11_sm = hsg11r1sm +hsg11r2sm+ hsg11r3sm+ hsg11r4sm+hsg11r5sm
gen n11_sf = hsg11r2sf+ hsg11r3sf+ hsg11r4sf+ hsg11r1sf+hsg11r5sf
gen n12_sm = hsg12r1sm +hsg12r2sm+ hsg12r3sm+ hsg12r4sm+hsg12r5sm
gen n12_sf = hsg12r2sf+ hsg12r3sf+ hsg12r4sf+ hsg12r1sf+hsg12r5sf

gen ratio_wm9 = n9_sf/n9_sm
gen ratio_wm10 = n10_sf/n10_sm
gen ratio_wm11 = n11_sf/n11_sm
gen ratio_wm12 = n12_sf/n12_sm





gen n_owng = (grade==1&boys==1)*n9_sm + (grade==2&boys==1)*n10_sm + (grade==3&boys==1)*n11_sm+(grade==4&boys==1)*n12_sm + (grade==1&boys==0)*n9_sf + (grade==2&boys==0)*n10_sf + (grade==3&boys==0)*n11_sf+(grade==4&boys==0)*n12_sf 

gen n_owng_opp = (grade==1&boys==0)*n9_sm + (grade==2&boys==0)*n10_sm + (grade==3&boys==0)*n11_sm+(grade==4&boys==0)*n12_sm + (grade==1&boys==1)*n9_sf + (grade==2&boys==1)*n10_sf + (grade==3&boys==1)*n11_sf+(grade==4&boys==1)*n12_sf 


gen pctg9 = ( hsg9r2sf+ hsg9r3sf+ hsg9r4sf+ hsg9r1sf+hsg9r5sf)/( hsg9r1sm +hsg9r2sm+ hsg9r3sm+ hsg9r4sm+hsg9r5sm)
gen pctg10 = ( hsg10r2sf+ hsg10r3sf+ hsg10r4sf+ hsg10r1sf+hsg10r5sf)/(hsg10r1sm +hsg10r2sm+ hsg10r3sm+ hsg10r4sm+hsg10r5sm)
gen pctg11 = ( hsg11r2sf+ hsg11r3sf+ hsg11r4sf+ hsg11r1sf+hsg11r5sf)/(hsg11r1sm +hsg11r2sm+ hsg11r3sm+ hsg11r4sm+hsg11r5sm)
gen pctg12 = ( hsg12r2sf+ hsg12r3sf+ hsg12r4sf+ hsg12r1sf+hsg12r5sf)/(hsg12r1sm +hsg12r2sm+ hsg12r3sm+ hsg12r4sm+hsg12r5sm)

 
gen sexratio_owngrade =   pctg9 if grade == 1
replace sexratio_owngrade = pctg10 if grade==2
replace sexratio_owngrade =  pctg11 if grade==3
replace sexratio_owngrade = pctg12 if grade==4


gen sexratio_partgrade =   pctg9 if pgrade == 1
replace sexratio_partgrade = pctg10 if pgrade==2
replace sexratio_partgrade =  pctg11 if pgrade==3
replace sexratio_partgrade = pctg12 if pgrade==4



gen pct_owngp1 = (grade==1)*pctg10 + (grade==2)*pctg11 + (grade==3)*pctg12
gen pct_owngl1 = (grade==4)*pctg11 + (grade==2)*pctg9 + (grade==3)*pctg10



gen tot_f =hsg9r1sf+ hsg10r1sf+ hsg11r1sf+ hsg12r1sf+hsg9r2sf+ hsg10r2sf+ hsg11r2sf+ hsg12r2sf+hsg9r3sf+ hsg10r3sf+ hsg11r3sf+ hsg12r3sf+hsg9r4sf+ hsg10r4sf+ hsg11r4sf+ hsg12r4sf+hsg9r5sf+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf

gen totstud_sex = hsg9r1sm +  hsg10r1sm+ hsg11r1sm+ hsg12r1sm+ hsg9r1sf+ hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r2sm+ hsg10r2sm+ hsg11r2sm +hsg12r2sm +hsg9r2sf +hsg10r2sf+ hsg11r2sf+ hsg12r2sf +hsg9r3sm + hsg10r3sm+ hsg11r3sm+ hsg12r3sm+ hsg9r3sf +hsg10r3sf+ hsg11r3sf +hsg12r3sf +hsg9r4sm +hsg10r4sm+ hsg11r4sm+ hsg12r4sm+ hsg9r4sf+ hsg10r4sf+ hsg11r4sf +hsg12r4sf+ hsg9r5sm+ hsg10r5sm+ hsg11r5sm+ hsg12r5sm+ hsg9r5sf+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf

gen fsex=hsg9r1sf*ssexf9r1+hsg10r1sf*ssexf10r1+hsg11r1sf*ssexf11r1+hsg12r1sf*ssexf12r1+hsg9r2sf*ssexf9r2+hsg10r2sf*ssexf10r2+hsg11r2sf*ssexf11r2+hsg12r2sf*ssexf12r2+hsg9r3sf*ssexf9r3+hsg10r3sf*ssexf10r3+hsg11r3sf*ssexf11r3+hsg12r3sf*ssexf12r3 +(hsg9r4sf+hsg9r5sf)*ssexf9r4 +(hsg10r4sf+hsg10r5sf)*ssexf10r4 +(hsg11r4sf+hsg11r5sf)*ssexf11r4+ (hsg12r4sf+hsg12r5sf)*ssexf12r4

gen fnosex=hsg9r1sf*(1-ssexf9r1)+hsg10r1sf*(1-ssexf10r1)+hsg11r1sf*(1-ssexf11r1)+hsg12r1sf*(1-ssexf12r1)+hsg9r2sf*(1-ssexf9r2)+hsg10r2sf*(1-ssexf10r2)+hsg11r2sf*(1-ssexf11r2)+hsg12r2sf*(1-ssexf12r2)+hsg9r3sf*(1-ssexf9r3)+hsg10r3sf*(1-ssexf10r3)+hsg11r3sf*(1-ssexf11r3)+hsg12r3sf*(1-ssexf12r3) +(hsg9r4sf+hsg9r5sf)*(1-ssexf9r4) +(hsg10r4sf+hsg10r5sf)*(1-ssexf10r4) +(hsg11r4sf+hsg11r5sf)*(1-ssexf11r4)+ (hsg12r4sf+hsg12r5sf)*(1-ssexf12r4)

gen msex =hsg9r1sm*ssexm9r1+hsg10r1sm*ssexm10r1+hsg11r1sm*ssexm11r1+hsg12r1sm*ssexm12r1+hsg9r2sm*ssexm9r2+hsg10r2sm*ssexm10r2+hsg11r2sm*ssexm11r2+hsg12r2sm*ssexm12r2+hsg9r3sm*ssexm9r3+hsg10r3sm*ssexm10r3+hsg11r3sm*ssexm11r3+hsg12r3sm*ssexm12r3 +(hsg9r4sm+hsg9r5sm)*ssexm9r4+ (hsg10r4sm+hsg10r5sm)*ssexm10r4 +(hsg11r4sm+hsg11r5sm)*ssexm11r4 +(hsg12r4sm+hsg12r5sm)*ssexm12r4

gen mnosex =hsg9r1sm*(1-ssexm9r1)+hsg10r1sm*(1-ssexm10r1)+hsg11r1sm*(1-ssexm11r1)+hsg12r1sm*(1-ssexm12r1)+hsg9r2sm*(1-ssexm9r2)+hsg10r2sm*(1-ssexm10r2)+hsg11r2sm*(1-ssexm11r2)+hsg12r2sm*(1-ssexm12r2)+hsg9r3sm*(1-ssexm9r3)+hsg10r3sm*(1-ssexm10r3)+hsg11r3sm*(1-ssexm11r3)+hsg12r3sm*(1-ssexm12r3)+ (hsg9r4sm+hsg9r5sm)*(1-ssexm9r4) +(hsg10r4sm+hsg10r5sm)*(1-ssexm10r4) +(hsg11r4sm+hsg11r5sm)*(1-ssexm11r4) +(hsg12r4sm+hsg12r5sm)*(1-ssexm12r4)
	
gen tot_f_all =hsf9r1+hsf10r1+hsf11r1+hsf12r1+hsf9r2+hsf10r2+hsf11r2+hsf12r2+hsf9r3+hsf10r3+hsf11r3+hsf12r3+hsf9r4+hsf10r4+hsf11r4+hsf12r4 +nhsf9r1+nhsf10r1+nhsf11r1+nhsf12r1+nhsf9r2+nhsf10r2+nhsf11r2+nhsf12r2+nhsf9r3+nhsf10r3+nhsf11r3+nhsf12r3+nhsf9r4+nhsf10r4+nhsf11r4+nhsf12r4
gen totstud_all =   hsm9r1+hsm10r1+hsm11r1+hsm12r1+hsm9r2+hsm10r2+hsm11r2+hsm12r2+hsm9r3+hsm10r3+hsm11r3+hsm12r3+hsm9r4+hsm10r4+hsm11r4+hsm12r4+hsf9r1+hsf10r1+hsf11r1+hsf12r1+hsf9r2+hsf10r2+hsf11r2+hsf12r2+hsf9r3+hsf10r3+hsf11r3+hsf12r3+hsf9r4+hsf10r4+hsf11r4+hsf12r4 +nhsm9r1+nhsm10r1+nhsm11r1+nhsm12r1+nhsm9r2+nhsm10r2+nhsm11r2+nhsm12r2+nhsm9r3+nhsm10r3+nhsm11r3+nhsm12r3+nhsm9r4+nhsm10r4+nhsm11r4+nhsm12r4+nhsf9r1+nhsf10r1+nhsf11r1+nhsf12r1+nhsf9r2+nhsf10r2+nhsf11r2+nhsf12r2+nhsf9r3+nhsf10r3+nhsf11r3+nhsf12r3+nhsf9r4+nhsf10r4+nhsf11r4+nhsf12r4

gen pctblack = nr2/totstud_all
gen pctwhite = nr1/totstud_all
gen pcthisp = nr3/totstud_all
gen pctother = nr4/totstud_all


gen ss=nr1+nr2+nr3+nr4
*gen fracout = 1-ss/sssample

gen sexratio_sex = fsex/(fsex+msex+fnosex+mnosex)
gen sexratio_nosex = fnosex/(fnosex+mnosex+fsex+msex)
gen sexratio=tot_f /(mnosex+msex)

egen totsex = total(yli==1&boy==0),by(sid)
egen totmatch = total(yli>0&boy==0),by(sid)

egen totsex_s = total(yli==1&sexprior==1&boy==0),by(sid)
egen totmatch_s = total(yli>0&sexprior==1&boy==0),by(sid)

egen totsex_ns = total(yli==1&sexprior==0&boy==0 ),by(sid)
egen totmatch_ns = total(yli>0&sexprior==0&boy==0),by(sid)

gen fracsex = totsex/totmatch

gen fracsex_s = totsex_s/totmatch_s
gen fracsex_ns = totsex_ns/totmatch_ns 

egen totsex_s1 = total(yli==1&sexprior==1&boy==0&race==1),by(sid)
egen totmatch_s1 = total(yli>0&sexprior==1&boy==0&race==1),by(sid)
egen totsex_ns1 = total(yli==1&sexprior==0&boy==0&race==1),by(sid)
egen totmatch_ns1 = total(yli>0&sexprior==0&boy==0&race==1),by(sid)
gen fracsex_s1 = totsex_s1/totmatch_s1
gen fracsex_ns1 = totsex_ns1/totmatch_ns1 

egen totsex_s2 = total(yli==1&sexprior==1&boy==0&race==2),by(sid)
egen totmatch_s2 = total(yli>0&sexprior==1&boy==0&race==2),by(sid)
egen totsex_ns2 = total(yli==1&sexprior==0&boy==0&race==2),by(sid)
egen totmatch_ns2 = total(yli>0&sexprior==0&boy==0&race==2),by(sid)
gen fracsex_s2 = totsex_s2/totmatch_s2
gen fracsex_ns2 = totsex_ns2/totmatch_ns2 

egen totsex_s3 = total(yli==1&sexprior==1&boy==0&race==3),by(sid)
egen totmatch_s3 = total(yli>0&sexprior==1&boy==0&race==3),by(sid)
egen totsex_ns3 = total(yli==1&sexprior==0&boy==0&race==3),by(sid)
egen totmatch_ns3 = total(yli>0&sexprior==0&boy==0&race==3),by(sid)
gen fracsex_s3 = totsex_s3/totmatch_s3
gen fracsex_ns3 = totsex_ns3/totmatch_ns3 

  
gen sexratio_w9 =(hsg9r1sf)/(hsg9r1sm     + 1000*(hsg9r1sm  ==0))
gen sexratio_b9 =(hsg9r2sf)/(hsg9r2sm    + 1000*(hsg9r2sm  ==0))
gen sexratio_h9 =(hsg9r3sf)/(hsg9r3sm  + 1000*(hsg9r3sm  ==0))
gen sexratio_o9 =(hsg9r4sf+hsg9r5sf)/(hsg9r4sm  +hsg9r5sm   + 1000*(hsg9r4sm  +hsg9r5sm  ==0))  

gen sexratio_w10 =(hsg10r1sf)/(hsg10r1sm   + 1000*(hsg10r1sm  ==0))
gen sexratio_b10 =(hsg10r2sf)/(hsg10r2sm   + 1000*(hsg10r2sm  ==0))
gen sexratio_h10 =(hsg10r3sf)/(hsg10r3sm   + 1000*(hsg10r3sm  ==0))
gen sexratio_o10 =(hsg10r4sf+hsg10r5sf)/(hsg10r4sm  +hsg10r5sm   + 1000*(hsg10r4sm + hsg10r5sm ==0))

gen sexratio_w11 =(hsg11r1sf)/(hsg11r1sm   + 1000*(hsg11r1sm  ==0))
gen sexratio_b11 =(hsg11r2sf)/(hsg11r2sm   + 1000*(hsg11r2sm  ==0))
gen sexratio_h11 =(hsg11r3sf)/(hsg11r3sm   + 1000*(hsg11r3sm  ==0))
gen sexratio_o11 =(hsg11r4sf+hsg11r5sf)/(hsg11r4sm +hsg11r5sm  + 1000*(hsg11r4sm  +hsg11r5sm  ==0))

gen sexratio_w12 =(hsg12r1sf)/(hsg12r1sm  + 1000*(hsg12r1sm + hsg12r1sf==0))
gen sexratio_b12 =(hsg12r2sf)/(hsg12r2sm   + 1000*(hsg12r2sm + hsg12r2sf==0))
gen sexratio_h12 =(hsg12r3sf)/(hsg12r3sm   + 1000*(hsg12r3sm + hsg12r3sf==0))
gen sexratio_o12 =(hsg12r4sf+hsg12r5sf)/(hsg12r4sm  +hsg12r5sm +  1000*(hsg12r4sm  +hsg12r5sm  ==0))
 

gen pctnonwhite = (nr2+nr3+nr4)/totstud_all

gen sexratio_match =sexratio_w9*(yliss==1|yliss==5)*(yliss_r==1|yliss_r==5) + sexratio_w10*(yliss==2|yliss==6)*(yliss_r==1|yliss_r==5) + sexratio_w11*(yliss==3|yliss==7)*(yliss_r==1|yliss_r==5) + sexratio_w12*(yliss==4|yliss==8)*(yliss_r==1|yliss_r==5) +   sexratio_b9*(yliss==1|yliss==5)*(yliss_r==2|yliss_r==6) + sexratio_b10*(yliss==2|yliss==6)*(yliss_r==2|yliss_r==6) + sexratio_b11*(yliss==3|yliss==7)*(yliss_r==2|yliss_r==6) + sexratio_b12*(yliss==4|yliss==8)*(yliss_r==2|yliss_r==6) +   sexratio_h9*(yliss==1|yliss==5)*(yliss_r==3|yliss_r==7) + sexratio_h10*(yliss==2|yliss==6)*(yliss_r==3|yliss_r==7) + sexratio_h11*(yliss==3|yliss==7)*(yliss_r==3|yliss_r==7) + sexratio_h12*(yliss==4|yliss==8)*(yliss_r==3|yliss_r==7) +  sexratio_o9*(yliss==1|yliss==5)*(yliss_r==4|yliss_r==8) + sexratio_o10*(yliss==2|yliss==6)*(yliss_r==4|yliss_r==8) + sexratio_o11*(yliss==3|yliss==7)*(yliss_r==4|yliss_r==8) + sexratio_b12*(yliss==4|yliss==8)*(yliss_r==4|yliss_r==8)
gen sexratio_owntype = (grade==1&race==1)*sexratio_w9 + (grade==2&race==1)*sexratio_w10 + (grade==3&race==1)*sexratio_w11 + (grade==4&race==1)*sexratio_w12 + (grade==1&race==2)*sexratio_b9 + (grade==2&race==2)*sexratio_b10 + (grade==3&race==2)*sexratio_b11 + (grade==4&race==2)*sexratio_b12 + (grade==1&race==3)*sexratio_h9 + (grade==2&race==3)*sexratio_h10 + (grade==3&race==3)*sexratio_h11 + (grade==4&race==3)*sexratio_h12 + (grade==1&race==4)*sexratio_o9 + (grade==2&race==4)*sexratio_o10 + (grade==3&race==4)*sexratio_o11 + (grade==4&race==4)*sexratio_o12

gen sp =sexprior if girl==1
gen intspg = sexprior*grade
gen intsppg = sexprior*pgrade
gen intgrade = grade*pgrade 

intspg intsppg intgrade

*W cens sample RESULTS IN PAPER:
*replace sexratio_match =  pctg9*(yliss==1|yliss==5) + pctg10*(yliss==2|yliss==6)  +  pctg11*(yliss==3|yliss==7) +  pctg12*(yliss==4|yliss==8) if (yliss==0|yliss_r==0)&yli>0&sexratio_match == 0
*replace sexratio_match =  pctr1*(yliss_r==1|yliss_r==5) + pctr2*(yliss_r==2|yliss_r==6)  +  pctr3*(yliss_r==3|yliss_r==7) +  pctr4*(yliss_r==4|yliss_r==8) if (yliss==0|yliss_r==0)&yli>0&sexratio_match == 0

replace sexratio_match = sexratio_owntype if (yliss_r==0&yliss_r==0)&sexratio_match==0

gen pgrademis = (pgrade==0)
gen pracemis = (prace==0)
 
  
 qui xi: probit sex sexratio_match   sexprior grade   pgrade i.race   i.prace intspg intsppg intgrade     i.sid if yliss>0&yliss_r>0&girl==1&sexratio_match<5  , cl(sid)
margins,  dydx(sexratio_match   sexprior  grade pgrade)  
  
qui xi: probit sex sexratio_match  sexprior  grade  pgrade i.race  i.prace  pctblack pcthisp pctother pctwhite fsex msex fnosex  mnosex    if e(sample)==1  , cl(sid)
margins,  dydx(sexratio_match  sexprior  grade  pgrade  )  

 

 /*
gen group1 = (sexratio<=.898)
mean sexcurallss if yli>0 , over(group1)
lincom [sexcurallss]1 -[sexcurallss]0

gen group2 = (sexratio_ownrace<.8856572)
mean sexcurallss if yli>0 , over(group2)
lincom [sexcurallss]1 -[sexcurallss]0

gen group3 = (sexratio_match<.8934198)
mean sexcurallss  if   yli>0 , over(group3)
lincom [sexcurallss]1 -[sexcurallss]0
 
*collapse sexratio pctr1 pctr2 sexratio_w* sexratio_b*, by(sid)

*MINORITY MATCHING OUTSIDE RACE INCREASED BY DECREASES IN PEER POPULATION
gen tot_fem =hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r1sf+  hsg10r2sf+ hsg11r2sf+ hsg12r2sf+ hsg9r2sf+hsg10r3sf+ hsg11r3sf+ hsg12r3sf+ hsg9r3sf+hsg10r4sf+ hsg11r4sf+ hsg12r4sf+ hsg9r4sf+ hsg10r5sf+ hsg11r5sf+ hsg12r5sf+ hsg9r5sf
gen pctoffemyourrace =  (race==1)*(hsg10r1sf+ hsg11r1sf+ hsg12r1sf+ hsg9r1sf)/(tot_fem ) +(race==2)*(hsg10r2sf+ hsg11r2sf+ hsg12r2sf+ hsg9r2sf)/(tot_fem ) +(race==3)*(hsg10r3sf+ hsg11r3sf+ hsg12r3sf+ hsg9r3sf)/(tot_fem ) +(race==4|race==5)*(hsg10r4sf+ hsg11r4sf+ hsg12r4sf+ hsg9r4sf+hsg10r5sf+ hsg11r5sf+ hsg12r5sf+ hsg9r5sf)/(tot_fem )
gen minority = (race==1)*(pctwhite<.5) + (race==2)*(pctblack<.5) + (race==3)*(pcthisp<.5) + (race==4)*(pctother<.5)
gen matchoutrace = (match==1&prace~=race)
*xi: probit matchoutrace pctoffemyourrace  totstud    if boys==0&minority==1 
*xi: probit match  pctoffemyourrace  totstud    if boys==0&minority==1 

*OLD RESULTS IN PAPER:
qui xi: probit sex sexratio_match  sexprior  grade pgrade   i.race*i.prace intspg intsppg     if (yliss>0&yliss_r>0)&girl==1 , cl(sid)
margins,  dydx(sexratio_match  sexprior  grade pgrade)  
qui xi: probit sex sexratio_match  sexprior  grade pgrade   i.race*i.prace intspg intsppg   pctnonwhite fsex msex fnosex  mnosex  if (yliss>0&yliss_r>0)&girl==1 , cl(sid)
margins,  dydx(sexratio_match  sexprior  grade pgrade)  
qui xi: probit sex sexratio_match sexprior  grade pgrade  i.race*i.prace intspg intsppg  i.sid if (yliss>0&yliss_r>0)&girl==1 , cl(sid)
margins,  dydx(sexratio_match  sexprior  grade pgrade)  

gen older = (pgrade>=grade)*(pgrade<.)
gen mucholder = (pgrade>=grade+1)*(pgrade<.)

gen younger = (pgrade<grade)*(pgrade<.)
gen muchyounger = (pgrade<grade-1)*(pgrade<.)

gen young = (pgrade<3)
gen old = (pgrade>2)
gen sexold = old*sex
gen nosexold = old*(1-sex)

gen fresh = (pgrade==1)
gen senior = (pgrade==4)


gen samerace = (prace==race) if prace < .
gen samegrade = (pgrade==grade) if pgrade < .
gen samegradeorhigher = (pgrade>=grade) if pgrade < .
gen samegradeorlower = (pgrade<=grade) if pgrade < .


 
gen sexratio_owntype = (grade==1&race==1)*sexratio_w9 + (grade==2&race==1)*sexratio_w10 + (grade==3&race==1)*sexratio_w11 + (grade==4&race==1)*sexratio_w12 + (grade==1&race==2)*sexratio_b9 + (grade==2&race==2)*sexratio_b10 + (grade==3&race==2)*sexratio_b11 + (grade==4&race==2)*sexratio_b12 + (grade==1&race==3)*sexratio_h9 + (grade==2&race==3)*sexratio_h10 + (grade==3&race==3)*sexratio_h11 + (grade==4&race==3)*sexratio_h12 + (grade==1&race==4)*sexratio_o9 + (grade==2&race==4)*sexratio_o10 + (grade==3&race==4)*sexratio_o11 + (grade==4&race==4)*sexratio_o12

xi: probit older pct_owng sexprior   grade  i.race  intspg    i.sid  if boys==0&match==1



*unconditional on matching
xi: probit older pct_owng sexprior  i.grade  i.race  intspg    pctnonwhite  totstud_all   if boys==1&match==1&race==1


xi: probit younger sexratio sexprior  i.grade  i.race  intspg     if boys==1&match==1 
  
xi: probit fresh sexratio_owntype  sex sexprior  i.grade i.prace i.race  intspg i.sid if boys==1&match==1 , cl(sid)
 
xi: probit muchyounger sexratio_owntype  sex sexprior  i.grade i.prace i.race  intspg i.sid if boys==1&match==1 , cl(sid)
 
 
xi: probit senior sexratio_owntype  sex sexprior  i.grade i.prace i.race  intspg i.sid if boys==0&match==1&sex==0 , cl(sid)
   
xi: probit mucholder sexratio_owntype  sex sexprior  i.grade i.prace i.race  intspg i.sid if boys==0&match==1&sex==0 , cl(sid)
  
 
 
 

 collapse sexratio sexratio_sex sexratio_nosex fracsex_s* fracsex_ns* nr1 nr2 nr3 nr4 fracsex pctr1 pctr2 pctr3 pctr4 sexratio_w* sexratio_b* ss sssample   schtype, by(sid)
replace fracsex_s=. if fracsex_s==0
sum fracsex* if sexratio<.475
sum fracsex* if sexratio>.475
gen group1 = (sexratio<.475)
mean fracsex, over(group1)
lincom [fracsex]1 - [fracsex]0

xi: reg fracsex  sexratio  i.schtype nr1 nr2 nr3 nr4 , cl(sid)



 
gen sexratio_owntype = (grade==1&race==1)*sexratio_w9 + (grade==2&race==1)*sexratio_w10 + (grade==3&race==1)*sexratio_w11 + (grade==4&race==1)*sexratio_w12 + (grade==1&race==2)*sexratio_b9 + (grade==2&race==2)*sexratio_b10 + (grade==3&race==2)*sexratio_b11 + (grade==4&race==2)*sexratio_b12 + (grade==1&race==3)*sexratio_h9 + (grade==2&race==3)*sexratio_h10 + (grade==3&race==3)*sexratio_h11 + (grade==4&race==3)*sexratio_h12 + (grade==1&race==4)*sexratio_o9 + (grade==2&race==4)*sexratio_o10 + (grade==3&race==4)*sexratio_o11 + (grade==4&race==4)*sexratio_o12

gen ownrace = (race== prace)
gen owngrade = (grade==pgrade)

qui xi:probit sexcurallss sexratio     if (relcurallss==1|sexcurallss==1)&boys==1 
est store sex_gr_noreg
qui xi:probit sexcurallss sexratio_owntype      if (relcurallss==1|sexcurallss==1)&boys==1  
est store sex_owntypegr_noreg
qui xi:probit match sexratio      if boys==1 
est store match_gr_noreg
qui xi:probit match sexratio_owntype      if boys==1 
qui est store match_owntypegr_noreg
est tab  match_owntypegr_noreg sex_owntypegr_noreg match_gr_noreg sex_gr_noreg,  keep(sexratio sexratio_owntype) se



qui xi:probit sexcurallss sexratio ownrace owngrade  i.race*grade    if (relcurallss==1|sexcurallss==1)&boys==0 
est store sex_gr_reg
qui xi:probit sexcurallss sexratio_owntype ownrace owngrade   i.race*grade  i.sid   if (relcurallss==1|sexcurallss==1)&boys==0  
est store sex_owntypegr_reg
qui xi:probit match sexratio ownrace owngrade  i.race*grade  if boys==0
est store match_gr_reg
qui xi:probit match sexratio_owntype ownrace owngrade i.race*grade i.sid if boys==0
qui est store match_owntypegr_reg
est tab  match_owntypegr_reg sex_owntypegr_reg match_gr_reg sex_gr_reg,  keep(sexratio sexratio_owntype) se stats(N r2_p)

  

qui xi:probit sexcurallss sexratio ownrace owngrade  i.race*grade    if (relcurallss==1|sexcurallss==1)&boys==1 
est store sex_gr_reg
qui xi:probit sexcurallss sexratio_owntype ownrace owngrade   i.race*grade  i.sid   if (relcurallss==1|sexcurallss==1)&boys==1  
est store sex_owntypegr_reg
qui xi:probit match sexratio ownrace owngrade  i.race*grade  if boys==1
est store match_gr_reg
qui xi:probit match sexratio_owntype ownrace owngrade i.race*grade i.sid if boys==1
qui est store match_owntypegr_reg


est tab  match_owntypegr_reg sex_owntypegr_reg match_gr_reg sex_gr_reg,  keep(sexratio sexratio_owntype) se stats(N r2_p)
 
