function f = like_dynamic(beta0,YY,type,mm_nsw,mm_nsm,district,term,female,YYs,ED,PED,AGE,PAGE)
N=size(YY,1);
rho  =  -exp(beta0(1));
A=   exp(beta0(2))/(1+exp(beta0(2)));
T=1;
euler = 0.57721;
nterms=2;
ntypes = max(type);
nm = ntypes*nterms;
norm=ntypes+1;
Nd = max(district);

iage=(type>2)+1;


c =   exp(beta0(3))./(1+exp(beta0(3)));

bm_near =  beta0(4);
bf_near =  beta0(5);
bf_page =   beta0(6);
bm_page =  beta0(7);
bf_ped  =  beta0(8);
 bm_ped=   beta0(9);

 

 

N_age=max(max(AGE))+1;
N_ed=max(max(ED))+1;

beta=.95;

Pft_new_par=(1/nm)*ones(ntypes,nm,Nd,T);
Pmt_new_par=(1/nm)*ones(ntypes,nm,Nd,T);
Pmatchf_new_par=.25*ones(ntypes,nm,Nd,T);
Pmatchm_new_par=.25*ones(ntypes,nm,Nd,T);
flagg = zeros(Nd,1);

parfor k=1:Nd
    Uftemp = zeros(ntypes,nm,T);
    Umtemp = zeros(ntypes,nm,T);
    Ptempf_dyn = zeros(ntypes,nm,T);
    Ptempm_dyn = zeros(ntypes,nm,T);
    Pmatchf_new=.25*ones(ntypes,nm,T);
    Pmatchm_new=.25*ones(ntypes,nm,T);
    
    Umatf =  bf_near*term + bf_page.*(PAGE ) + bf_ped.*PED;
    Uf(:,:,1) = c*Umatf ;
    
    
    Umatm =  bm_near*term + bm_page.*(PAGE ) + bm_ped.*PED;
    Um(:,:,1) = c*Umatm ;
    
    Pft_new(:,:,1)=exp((Uf ))./(sum(exp((Uf  ) ),2)*ones(1,nm));
    Pmt_new(:,:,1)=exp((Um ))./(sum(exp((Um  ) ),2)*ones(1,nm));
    
    counter=0;
    tmp_dyn =1;
    while tmp_dyn >.0001 %this loop sets an initial vector of Pmatch (Pmatch0) across time
        Ptempfo_dyn=squeeze(Pmatchf_new(:,:,:));
        Ptempmo_dyn=squeeze(Pmatchm_new(:,:,:));
        %initial guess at the per=period probability of matching
        t=T;
        while t>0
            Ptempf=squeeze(Pmatchf_new(:,:,t));%.250*ones(size(squeeze(Pmatchf_new(:,:,k,t))));%
            Ptempm=squeeze(Pmatchm_new(:,:,t));%.250*ones(size(squeeze(Pmatchm_new(:,:,k,t))));%
            
            Nft   = [mm_nsw(:,k)]*ones(1,nm);
            Nmt   = [mm_nsm(:,k)]*ones(1,nm);
            
            Uft= c.*(Umatf + log(Ptempf./(Ptempf(:,norm)*ones(1,nm)))) ;% + (1-Ptempf).*CV_f ;
            Umt= c.*(Umatm + log(Ptempm./(Ptempm(:,norm)*ones(1,nm))))  ;%+ (1-Ptempm).*CV_m ;
            Pft=exp(Uft)./(sum(exp(Uft),2)*ones(1,nm));
            Pmt=exp(Umt)./(sum(exp(Umt),2)*ones(1,nm));
            Sft= Nft.*Pft ;
            Smt= Nmt.*Pmt;
            
            zero_m = (Smt==0);
            zero_f = (Sft==0);
            
            Ptempf= (A.*(.5+.5*([Smt(1:ntypes,1:ntypes)' Smt(1:ntypes,ntypes+1:2*ntypes)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_f==0) ;
            Ptempm= (A.*(.5+.5*([Sft(1:ntypes,1:ntypes)' Sft(1:ntypes,ntypes+1:2*ntypes)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_m==0);
            Ptempf_leon =  (min([Smt(1:ntypes,1:ntypes)' Smt(1:ntypes,ntypes+1:2*ntypes)'],(Sft))./(Sft+(Sft==0))).*(zero_f==0);
            Ptempm_leon =  (min([Sft(1:ntypes,1:ntypes)' Sft(1:ntypes,ntypes+1:2*ntypes)'],(Smt))./(Smt+(Smt==0))).*(zero_m==0);
            one_mat_f = (Ptempf>=1);
            one_mat_m = (Ptempm>=1);
            Ptempf(:,1:ntypes) = Ptempf(:,1:ntypes).*(one_mat_m(:,1:ntypes)'==0) + Ptempf_leon(:,1:ntypes).*(one_mat_m(:,1:ntypes)'==1);
            Ptempm(:,1:ntypes) = Ptempm(:,1:ntypes).*(one_mat_f(:,1:ntypes)'==0) + Ptempm_leon(:,1:ntypes).*(one_mat_f(:,1:ntypes)'==1);
            Ptempf(:,ntypes+1:2*ntypes) = Ptempf(:,ntypes+1:2*ntypes).*(one_mat_m(:,ntypes+1:2*ntypes)'==0) + Ptempf_leon(:,ntypes+1:2*ntypes).*(one_mat_m(:,ntypes+1:2*ntypes)'==1);
            Ptempm(:,ntypes+1:2*ntypes) = Ptempm(:,ntypes+1:2*ntypes).*(one_mat_f(:,ntypes+1:2*ntypes)'==0) + Ptempm_leon(:,ntypes+1:2*ntypes).*(one_mat_f(:,ntypes+1:2*ntypes)'==1);
            Ptempf =max(min(.99999,Ptempf),.00001);
            Ptempm =max(min(.99999,Ptempm),.00001);
            Ptempf_dyn(:,:,t)= Ptempf ;
            Ptempm_dyn(:,:,t)= Ptempm ;
            Umtemp(:,:,t)=  Umt;
            Uftemp(:,:,t)=  Uft;
            t=t-1;
        end
        Pmatchf_new =Ptempf_dyn ;
        Pmatchm_new =Ptempm_dyn ;
        Uf =Uftemp ;
        Um =Umtemp ;
        Pft_new(:,:,1)=exp((Uf(:,:,1) ) )./(sum(exp((Uf(:,:,1) ) ),2)*ones(1,nm));
        Pmt_new(:,:,1)=exp((Um(:,:,1) ) )./(sum(exp((Um(:,:,1) ) ),2)*ones(1,nm));
        tmp_dyn = max(max(max([abs(Ptempfo_dyn-squeeze(Pmatchf_new(:,:,:))) abs(Ptempmo_dyn-squeeze(Pmatchm_new(:,:,:)))])));
        counter=counter+1;
        if counter>1000
            tmp_dyn= 0;
            flagg(k,1)=1;
            Pft_new=(1/nm)*ones(ntypes,nm,T);
            Pmt_new=(1/nm)*ones(ntypes,nm,T);
            Pmatchf_new=1*ones(ntypes,nm,T);
            Pmatchm_new=1*ones(ntypes,nm,T);
        end
    end
    
    Pft_new_par(:,:,k,:)=Pft_new;
    Pmt_new_par(:,:,k,:)=Pmt_new;
    
    Pmatchf_new_par(:,:,k,:)= Pmatchf_new(:,:,:);
    Pmatchm_new_par(:,:,k,:)= Pmatchm_new(:,:,:);
    
end


parfor i=1:N
    for t = 1:T
        Psearch(i,:,t) = Pft_new_par(type(i),:,district(i,1),t).*(female(i,1)==1)    + Pmt_new_par(type(i),:,district(i,1),t).*(female(i,1)==0);
        Pmatch(i,:,t)  = Pmatchf_new_par(type(i),:,district(i,1),t).*(female(i,1)==1)+ Pmatchm_new_par(type(i),:,district(i,1),t).*(female(i,1)==0);
        %        end
    end
end


m1 = (sum(YY(:,:),2)>0);
nm1 =(sum(YY(:,:),2)==0);%.*(NY1==0);

Like = zeros(N,T);
for t= 1:T
    if t == 1
        %Works!
         %Like(:,t)=   m1.*sum(YY(:,:,t).*(log(Psearch(:,:,t))+log(Pmatch(:,:,t))),2)+nm1.*(sum(YYs(:,:,t).*(log(Psearch(:,:,t))+log(1-Pmatch(:,:,t))),2));
        %        cens_like(:,t) = sum(cens_mat1.*Psearch(:,:,t).*Pmatch(:,:,t),2);
        Like(:,t)=   m1.*sum(YY(:,:,t).*(log(Psearch(:,:,t))+log(Pmatch(:,:,t))),2)+nm1.*log(sum(Psearch(:,:,t).*(1-Pmatch(:,:,t)),2)) ;% + NY1.*(log(cens_like(:,t) +  (cens_like(:,t)==0) ));
    end
end
%Not using likelihood contributions for old-matches at t=2
%Like(:,2) = Like(:,2).*(iage==1);
f=-sum(sum(Like));
if sum(flagg)>0
    f= 1e10
end
[f/1000 [rho A c [ bm_near bf_near bf_page bm_page bf_ped bm_ped]]]
